package leodbc.javaagent;

import java.lang.instrument.Instrumentation;

import leodbc.javaagent.instrumentor.DbcClassFileTransformer;
import leodbc.javaagent.res.Constants;

/**
 * Agente per la modifica dinamica del bytecode secondo le
 * specifiche del Design by Contract
 * 
 * @author Leonardo Cecchi
 */
public class LeoDbcJavaAgent 
{
	/**
	 * Avvio dell'agente
	 * 
	 * @param agentArgs Nessun argomento accettato (PER ORA)
	 * @param inst Connessione con la VM java
	 */
	public static void premain(String agentArgs, Instrumentation inst)
	{
		System.out.println("LeoDBC v"+Constants.VERSION+" start...");
		inst.addTransformer(new DbcClassFileTransformer());
	}
}
