package leodbc.javaagent.instrumentor;

import java.util.HashMap;
import java.util.Map;

/**
 * Cache che contiene le classi gi modificate per i contratti
 * 
 * @author Leonardo Cecchi
 */
public class InstrumentorCache 
{
	/**
	 * Contenitore della cache
	 */
	private Map<String, byte[]> cache;
	
	/**
	 * Inizializzazione
	 */
	public InstrumentorCache()
	{
		cache=new HashMap<String, byte[]>();
	}

	/**
	 * Ritorna una classe se  gi in cache
	 * 
	 * @param name Nome della classe
	 * @return Classe modificata oppure null
	 */
	public byte[] getFromCache(String name)
	{
		if(cache.containsKey(name))
		{
			return cache.get(name);
		} else
		{
			return null;
		}
	}
	
	/**
	 * Imposta un bytecode nella cache
	 * 
	 * @param name Nome della classe corrispondente
	 * @param byteCode Bytecode
	 */
	public void setCache(String name, byte[] byteCode)
	{
		cache.put(name, byteCode);
	}
}
