package leodbc.javaagent.res;

/**
 * Constanti in uso dell'agente java di LeoDbC
 * @author Leonardo Cecchi
 */
public class Constants 
{
	/**
	 * Debugging interno
	 */
	public static boolean INTERNAL_DEBUGGING=true;
	
	/**
	 * Versione
	 */
	public static String VERSION="0.1alpha";
		
	/**
	 * Marcatore delle condizioni 
	 */
	public static String CONDITION_MARKER="booleanCondition";
	
	/**
	 * Marcatore del lanciatore del metodo nella superclasse
	 */
	public static String LAUNCH_SUPERCLASS_MARKER="launchSuperclass";

	/**
	 * Nome del metodo di invariante
	 */
	public static String INVARIANT_METHOD_NAME="check_invariant";
	
	/**
	 * Prefisso di un metodo di precondizione
	 */
	public static String PREMETHOD_PREFIX="pre_";

	/**
	 * Prefisso di un metodo di precondizione
	 */
	public static String POSTMETHOD_PREFIX="post_";
	
	/**
	 * Schema di un premetodo
	 */
	public static String PREMETHOD_SCHEMA=
		"{ "+
		"leodbc.support.VariableStore _store=leodbc.support.VariableStoreFactory.get();"+
		"_store.addMethodMarker();"+
		LAUNCH_SUPERCLASS_MARKER+
		"if(!("+CONDITION_MARKER+")) {"+
		"throw new leodbc.support.ContractError(\"Wrong precondition\");"+
		"}"+
		"}";
	
	/**
	 * Schema di un premetodo
	 */
	public static String POSTMETHOD_SCHEMA=
		"{ "+
		"leodbc.support.VariableStore _store=leodbc.support.VariableStoreFactory.get(); try {"+
		LAUNCH_SUPERCLASS_MARKER+
		"if(!("+CONDITION_MARKER+")) {"+
		"throw new leodbc.support.ContractError(\"Wrong postcondition\");"+
		"} " +
		"} finally { _store.removeMethodAssociations(); }"+
		"}";
		
	/**
	 * Schema di un metodo di invariante
	 */
	public static String INVARIANT_METHOD=
		"public void "+INVARIANT_METHOD_NAME+"() { launchSuperclass "+
		"if(!("+CONDITION_MARKER+")) {" +
		"throw new leodbc.support.ContractError(\"Wrong class invariant\");"+
		"}"+
		"}";
	
	/**
	 * Schema di un check di una precondizione in un costruttore
	 */
	public static String CHECK_PRECONDITION_CONSTRUCTOR=
		"if(!("+CONDITION_MARKER+")) {"+
		"throw new leodbc.support.ContractError(\"Wrong precondition\");"+
		"}";
	
	/**
	 * Schema di un check di una precondizione in un costruttore
	 */
	public static String CHECK_POSTCONDITION_CONSTRUCTOR=
		"if(!("+CONDITION_MARKER+")) {"+
		"throw new leodbc.support.ContractError(\"Wrong postcondition\");"+
		"}";	

	/**
	 * Schema di un check di una precondizione in un costruttore
	 */
	public static String CHECK_ILLEGAL_ARGUMENT=
		"if(!("+CONDITION_MARKER+")) {"+
		"throw new IllegalArgumentException(\"Illegal argument\");"+
		"}";	
}
