package leodbc.javaagent.transformations;

import java.util.LinkedList;

import javassist.CannotCompileException;
import javassist.CtClass;
import javassist.NotFoundException;

/**
 * Trasformatore di classi che applica pi trasformazioni insieme
 * @author Leonardo Cecchi
 */
public class ClassTrasformerList implements ClassTransformer 
{
	/**
	 * Contenitore dei trasformatori
	 */
	LinkedList<ClassTransformer> list;
	
	/**
	 * Inizializzazione del trasformatore
	 */
	public ClassTrasformerList()
	{
		list=new LinkedList<ClassTransformer>();
	}
	
	/**
	 * Aggiunta di un nuovo trasformatore di classi in coda agli altri
	 * @param ct Nuovo trasformatore
	 */
	public void addClassTransformer(ClassTransformer ct)
	{
		list.add(ct);
	}
	
	/**
	 * Trasformazione di una classe
	 * @param clazz Classe
	 */
	public void transform(CtClass clazz) throws CannotCompileException, ClassNotFoundException, NotFoundException
	{
		for(ClassTransformer ct: list)
		{
			ct.transform(clazz);
		}
	}

}
