package leodbc.support;

/**
 * VariableStore astratto che usa l'autoboxing / autounboxing di Java 1.5
 * @author Leonardo Cecchi
 */
public abstract class AbstractVariableStore implements VariableStore 
{
	public boolean putValue(String name, int val) {
		return putValue(name, (Object)val);
	}

	public boolean putValue(String name, double val) {
		return putValue(name, (Object)val);
	}

	public boolean putValue(String name, long val) {
		return putValue(name, (Object)val);
	}

	public boolean putValue(String name, byte val) {
		return putValue(name, (Object)val);
	}
	
	public int getInt(String name)
	{
		return((Integer)getValue(name));
	}
	
	public double getDouble(String name)
	{
		return((Double)getValue(name));
	}
	
	public long getLong(String name)
	{
		return((Long)getValue(name));
	}
		
	public byte getByte(String name)
	{
		return((Byte)getValue(name));
	}
}
