package leodbc.support;

public interface VariableStore 
{
	/**
	 * Imposta un valore
	 * @param name Nome
	 * @param val Valore
	 */
	public abstract boolean putValue(String name, Object val);
	
	/**
	 * Imposta un valore
	 * @param name Nome
	 * @param val Valore
	 */
	public abstract boolean putValue(String name, int val);

	/**
	 * Imposta un valore
	 * @param name Nome
	 * @param val Valore
	 */
	public abstract boolean putValue(String name, double val);

	/**
	 * Imposta un valore
	 * @param name Nome
	 * @param val Valore
	 */
	public abstract boolean putValue(String name, long val);

	/**
	 * Imposta un valore
	 * @param name Nome
	 * @param val Valore
	 */
	public abstract boolean putValue(String name, byte val);
	
	/**
	 * Riprende un valore
	 * @return il valore memorizzato oppure null se non presente
	 */
	public abstract Object getValue(String name);
	
	/**
	 * Riprende un valore
	 * @return il valore memorizzato oppure null se non presente
	 */
	public abstract int getInt(String name);
	
	/**
	 * Riprende un valore
	 * @return il valore memorizzato oppure null se non presente
	 */
	public abstract double getDouble(String name);
	
	/**
	 * Riprende un valore
	 * @return il valore memorizzato oppure null se non presente
	 */
	public abstract long getLong(String name);
		
	/**
	 * Riprende un valore
	 * @return il valore memorizzato oppure null se non presente
	 */
	public abstract byte getByte(String name);

	/**
	 * Linea di separazione dello stack pe run metodo
	 */
	public abstract void addMethodMarker();

	/**
	 * Rimuove le associazioni di un metodo (ovvero tutto fino alla separation
	 * line compresa)
	 */
	public abstract void removeMethodAssociations();
}