package leodbc.testquattro;

import leodbc.support.LeoArgCheck;
import leodbc.support.LeoInvariant;
import leodbc.support.LeoPost;
import leodbc.support.LeoPre;

/**
 * Prova per le asserzioni ereditate
 * @author 2638966
 */
@LeoInvariant("count>=0")
public class ClasseBase 
{
	/**
	 * Numero di elementi presenti in questa classe
	 */
	int count;
	
	/**
	 * Costruttore
	 */
	public ClasseBase()
	{
		count=0;
	}
	
	@LeoPre("_store.putValue(\"oldcount\", count) && "+
			"count>=0")
	@LeoPost("_store.getInt(\"oldcount\")==(count-1)")
	public void add(@LeoArgCheck("$1!=null") Object o)
	{
		count++;
	}
	
	/**
	 * Test per le pre/post condizioni e vecchi valori
	 * @param a
	 * @param b
	 * @return Somma di due numeri
	 */
	@LeoPre("_store.putValue(\"a\", $1) && "+
			"_store.putValue(\"b\", $2) && "+
			"_store.putValue(\"somma\", $1+$2)")
	@LeoPost("_store.getInt(\"somma\")==$1")
	public int somma(int a, int b)
	{
		if(a>0)
		{
			return somma(a-1, b+1);
		} else
		{
			return b;
		}
	}
}
